MantisBT
Mantis Bug Tracker Workflow

View Issue Details Jump to Notes ] Issue History ] Print ]
IDProjectCategoryView StatusDate SubmittedLast Update
0023495Open CASCADE[OCCT] OCCT:VISpublic2012-10-27 16:242014-11-11 12:58
Reporterssv 
Assigned Tossv 
PrioritynormalSeverityminor 
StatusclosedResolutionfixed 
PlatformOSOS Version
Product Version 
Target Version[OCCT] 6.8.0Fixed in Version[OCCT] 6.8.0 
Summary0023495: Transformation problem: Shape Picker works on initial data set
DescriptionAs VIS Shape Picker works on initial TopoDS_Shape, taking advantage of OCCT standard selection mechanism, it is not compatible with any VTK filters affecting the location of the working data set. For instance, it is error-prone to use VIS picker with a pipeline comprising vtkTransform filter. As a result user will get highlighting inconsistent with the actual data position in viewer.

In order to have possibility to apply different transformations to the initial shape and nevertheless use VIS picker, user should apply the corresponding Location to the initial shape. This, however, leads to re-computation of the entire internal triangulation in VIS Data Source.

The following actions are proposed to be covered in scope of this issue:

1. Find a way to optimize VIS Data Source for already triangulated shapes having different Locations. In that case the internal discrete model should not be recalculated, only transformation should be applied to the existing one;

2. Update VIS user's guide to highlight the mentioned peculiarity of VIS picker (draw user's attention to the fact that it works on initial data set unlike standard VTK pickers working on the resulting polygonal data). The attached presentation can be used as a source for user's guide. Without having this issue mentioned in documentation, the behavior of VIS picker looks really weird in some cases.

TagsNo tags attached.
Test case number
Attached Filesppt file icon VIS_Prs.ppt (764,928 bytes) 2012-10-27 16:24
? file icon IVtkTools_ShapeDataSource.hxx (3,060 bytes) 2012-11-02 12:14
cxx file icon IVtkTools_ShapeDataSource.cxx (6,660 bytes) 2012-11-02 12:14

- Relationships
related to 0022859closedbugmaster Developers guide with code samples 
related to 0022877closedbugmaster Draw Harness - add plugin for VIS component 

-  Notes
(0022067)
ssv (developer)
2012-11-02 12:23

Dear Sergey,

Could you please take a look on the attached improvement for Shape Data Source? The following approach to optimization has been introduced:

1. In order to enable optimized processing of transformations, user enables Fast Transformation Mode: IVtkTools_ShapeDataSource::FastTransformModeOn;

2. Once user calls SetShape method, Data Source checks, whether the passed shape is a "partner" (in terms of OCCT) of the previously processed one (if any). If so, re-meshing will not happen. vtkTransform will be used instead.

I have also adjusted the overall code of IVtkTools_ShapeDataSource in order to fit coding rules.

P.S: I did not switch this issue to Resolved status as we still need to adjust User's Guide.
(0022114)
san (developer)
2012-11-06 20:42

Modified sources committed to GIT branch CR22877_1.
User's guide to be updated yet.
(0027557)
ssv (developer)
2014-01-20 16:28

Fix was ported to OCCT 6.7.0 for Windows platform (the same branch CR22877_1). It is still necessary to port it to X systems.
(0032270)
aba (developer)
2014-09-26 19:29

Dear Bugmaster,

please close the issue.

- Issue History
Date Modified Username Field Change
2012-10-27 16:24 ssv New Issue
2012-10-27 16:24 ssv Assigned To => szv
2012-10-27 16:24 ssv File Added: VIS_Prs.ppt
2012-11-02 12:14 ssv File Added: IVtkTools_ShapeDataSource.hxx
2012-11-02 12:14 ssv File Added: IVtkTools_ShapeDataSource.cxx
2012-11-02 12:14 ssv Assigned To szv => san
2012-11-02 12:23 ssv Note Added: 0022067
2012-11-02 12:23 ssv Status new => assigned
2012-11-06 20:41 san Relationship added related to 0022877
2012-11-06 20:42 san Note Added: 0022114
2013-02-14 13:38 bugmaster Project Open CASCADE => Internal
2014-01-20 16:28 ssv Note Added: 0027557
2014-09-18 09:58 abv Category PRODUCTS:VIS => OCCT:VIS
2014-09-18 10:39 bugmaster Project Internal => Open CASCADE
2014-09-26 19:29 aba Note Added: 0032270
2014-09-26 19:29 aba Assigned To san => bugmaster
2014-09-26 19:29 aba Status assigned => feedback
2014-09-26 19:29 aba Relationship added related to 0022859
2014-09-29 15:50 bugmaster Status feedback => tested
2014-09-29 15:50 bugmaster Status tested => verified
2014-09-29 15:50 bugmaster Resolution open => fixed
2014-09-29 15:50 bugmaster Assigned To bugmaster => ssv
2014-09-29 15:50 bugmaster Target Version => 6.8.0
2014-11-11 12:45 aiv Fixed in Version => 6.8.0
2014-11-11 12:58 aiv Status verified => closed


Copyright © 2000 - 2020 MantisBT Team
Powered by Mantis Bugtracker